// Copyright (c) 2024 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "SceneLoader.hpp"

using namespace Dawn;

const std::string SceneLoader::ASSET_TYPE = "scene";

SceneLoader::SceneLoader(
  const std::shared_ptr<AssetManager> assetManager,
  const std::string name
) :
  AssetLoader(assetManager, name),
  state(SceneLoaderState::INITIAL)
{
}

void SceneLoader::updateAsync() {
  switch(this->state) {
    case SceneLoaderState::INITIAL:
      this->jsonLoader = getAssetManager()->get<JSONLoader>(this->name);
      this->state = SceneLoaderState::LOADING_JSON;
      break;
    
    case SceneLoaderState::LOADING_JSON:
      break;
    
    default:
      break;
  }
}

void SceneLoader::updateSync() {

}

std::string SceneLoader::getAssetType() const {
  return SceneLoader::ASSET_TYPE;
}

std::shared_ptr<Scene> SceneLoader::getScene() {
  return scene;
}

SceneLoader::~SceneLoader() {
  
}